Index: source/gui/scripting/ScriptFunctions.cpp
===================================================================
--- source/gui/scripting/ScriptFunctions.cpp	(Revision 14461)
+++ source/gui/scripting/ScriptFunctions.cpp	(Arbeitskopie)
@@ -679,6 +851,11 @@
 	scriptInterface.RegisterFunction<bool, std::string, &HotkeyIsPressed_>("HotkeyIsPressed");
 	scriptInterface.RegisterFunction<void, std::wstring, &DisplayErrorDialog>("DisplayErrorDialog");
 	scriptInterface.RegisterFunction<CScriptVal, &GetProfilerState>("GetProfilerState");
+	scriptInterface.RegisterFunction<void, &ExitProgram>("Exit");
+	scriptInterface.RegisterFunction<bool, &IsPaused>("IsPaused");
+	scriptInterface.RegisterFunction<void, bool, &SetPaused>("SetPaused");
+	scriptInterface.RegisterFunction<int, &GetFps>("GetFPS");
+	scriptInterface.RegisterFunction<CStr, int, &GetBuildTimestamp>("BuildTime");
 
 	// User report functions
 	scriptInterface.RegisterFunction<bool, &IsUserReportEnabled>("IsUserReportEnabled");
@@ -687,6 +864,8 @@
 	scriptInterface.RegisterFunction<void, std::string, int, std::wstring, &SubmitUserReport>("SubmitUserReport");
 
 	// Development/debugging functions
+	scriptInterface.RegisterFunction<void, unsigned int, &StartJsTimer>("StartXTimer");
+	scriptInterface.RegisterFunction<void, unsigned int, &StopJsTimer>("StopXTimer");
 	scriptInterface.RegisterFunction<void, float, &SetSimRate>("SetSimRate");
 	scriptInterface.RegisterFunction<float, &GetSimRate>("GetSimRate");
 	scriptInterface.RegisterFunction<void, int, &SetTurnLength>("SetTurnLength");
Index: source/gui/GUIManager.h
===================================================================
--- source/gui/GUIManager.h	(Revision 14461)
+++ source/gui/GUIManager.h	(Arbeitskopie)
@@ -22,8 +22,10 @@
 
 #include "lib/input.h"
 #include "lib/file/vfs/vfs_path.h"
+#include "ps/CLogger.h"
 #include "ps/CStr.h"
 #include "scriptinterface/ScriptVal.h"
+#include "scriptinterface/ScriptInterface.h"
 
 #include <set>
 
@@ -46,10 +48,15 @@
 {
 	NONCOPYABLE(CGUIManager);
 public:
-	CGUIManager(ScriptInterface& scriptInterface);
+	CGUIManager();
 	~CGUIManager();
 
-	ScriptInterface& GetScriptInterface() { return m_ScriptInterface; }
+	shared_ptr<ScriptInterface> GetScriptInterface() 
+	{ 
+		return m_ScriptInterface; 
+	}
+	shared_ptr<ScriptRuntime> GetRuntime() { return m_ScriptRuntime; }
+	shared_ptr<CGUI> GetActiveGUI() { return top(); }
 
 	/**
 	 * Returns whether there are any current pages.
@@ -59,20 +66,21 @@
 	/**
 	 * Load a new GUI page and make it active. All current pages will be destroyed.
 	 */
-	void SwitchPage(const CStrW& name, CScriptVal initData);
+	void SwitchPage(const CStrW& name, ScriptInterface* srcScriptInterface, CScriptVal initData);
 
 	/**
 	 * Load a new GUI page and make it active. All current pages will be retained,
 	 * and will still be drawn and receive tick events, but will not receive
 	 * user inputs.
 	 */
-	void PushPage(const CStrW& name, CScriptVal initData);
+	void PushPage(const CStrW& pageName, shared_ptr<ScriptInterface::StructuredClone> initData);
 
 	/**
 	 * Unload the currently active GUI page, and make the previous page active.
 	 * (There must be at least two pages when you call this.)
 	 */
 	void PopPage();
+	void PopPageCB(shared_ptr<ScriptInterface::StructuredClone> args);
 
 	/**
 	 * Display a modal message box with an "OK" button.
@@ -115,11 +123,6 @@
 	void SendEventToAll(const CStr& eventName);
 
 	/**
-	 * See CGUI::GetScriptObject; applies to the currently active page.
-	 */
-	JSObject* GetScriptObject();
-
-	/**
 	 * See CGUI::TickObjects; applies to @em all loaded pages.
 	 */
 	void TickObjects();
@@ -134,10 +137,14 @@
 	 */
 	void UpdateResolution();
 
-	/**
-	 * Calls the current page's script function getSavedGameData() and returns the result.
-	 */
-	CScriptVal GetSavedGameData();
+ 	/**
+ 	 * Calls the current page's script function getSavedGameData() and returns the result.
+	 * The first overload also returns a pointer to the ScriptInterface the returned CScriptVal belongs to.
+ 	 */
+	CScriptVal GetSavedGameData(ScriptInterface*& pPageScriptInterface);
+	std::string GetSavedGameData();
+ 
+	void RestoreSavedGameData(std::string jsonData);
 
 private:
 	struct SGUIPage
@@ -146,7 +153,8 @@
 		boost::unordered_set<VfsPath> inputs; // for hotloading
 
 		JSContext* cx;
-		CScriptValRooted initData; // data to be passed to the init() function
+		shared_ptr<ScriptInterface::StructuredClone> initData; // data to be passed to the init() function
+		CStrW callbackPageName;
 
 		shared_ptr<CGUI> gui; // the actual GUI page
 	};
@@ -154,13 +162,13 @@
 	void LoadPage(SGUIPage& page);
 
 	shared_ptr<CGUI> top() const;
+	
+	shared_ptr<CGUI> m_CurrentGUI; // used to latch state during TickObjects/LoadPage (this is kind of ugly)
+	shared_ptr<ScriptRuntime> m_ScriptRuntime;
+	shared_ptr<ScriptInterface> m_ScriptInterface;
 
 	typedef std::vector<SGUIPage> PageStackType;
 	PageStackType m_PageStack;
-
-	shared_ptr<CGUI> m_CurrentGUI; // used to latch state during TickObjects/LoadPage (this is kind of ugly)
-
-	ScriptInterface& m_ScriptInterface;
 };
 
 extern CGUIManager* g_GUI;
Index: source/gui/GUIManager.cpp
===================================================================
--- source/gui/GUIManager.cpp	(Revision 14461)
+++ source/gui/GUIManager.cpp	(Arbeitskopie)
@@ -26,7 +26,6 @@
 #include "ps/CLogger.h"
 #include "ps/Profile.h"
 #include "ps/XML/Xeromyces.h"
-#include "scripting/ScriptingHost.h"
 #include "scriptinterface/ScriptInterface.h"
 
 CGUIManager* g_GUI = NULL;
@@ -48,13 +47,12 @@
 	return g_GUI->HandleEvent(ev);
 }
 
-CGUIManager::CGUIManager(ScriptInterface& scriptInterface) :
-	m_ScriptInterface(scriptInterface)
+CGUIManager::CGUIManager()
 {
-	ENSURE(ScriptInterface::GetCallbackData(scriptInterface.GetContext()) == NULL);
-	scriptInterface.SetCallbackData(this);
-
-	scriptInterface.LoadGlobalScripts();
+	m_ScriptRuntime = g_ScriptRuntime;
+	m_ScriptInterface.reset(new ScriptInterface("Engine", "GUIManager", m_ScriptRuntime));
+	m_ScriptInterface->SetCallbackData(this);
+	m_ScriptInterface->LoadGlobalScripts();
 }
 
 CGUIManager::~CGUIManager()
@@ -66,17 +64,25 @@
 	return !m_PageStack.empty();
 }
 
-void CGUIManager::SwitchPage(const CStrW& pageName, CScriptVal initData)
+void CGUIManager::SwitchPage(const CStrW& pageName, ScriptInterface* srcScriptInterface, CScriptVal initData)
 {
+	// The page stack is cleared (including the script context where initData came from),
+	// therefore we have to clone initData.
+	shared_ptr<ScriptInterface::StructuredClone> initDataClone;
+	if (initData.get() != JSVAL_VOID)
+	{
+		ENSURE(srcScriptInterface);
+		initDataClone = srcScriptInterface->WriteStructuredClone(initData.get());
+	}
 	m_PageStack.clear();
-	PushPage(pageName, initData);
+	PushPage(pageName, initDataClone);
 }
 
-void CGUIManager::PushPage(const CStrW& pageName, CScriptVal initData)
+void CGUIManager::PushPage(const CStrW& pageName, shared_ptr<ScriptInterface::StructuredClone> initData)
 {
 	m_PageStack.push_back(SGUIPage());
 	m_PageStack.back().name = pageName;
-	m_PageStack.back().initData = CScriptValRooted(m_ScriptInterface.GetContext(), initData);
+	m_PageStack.back().initData = initData;
 	LoadPage(m_PageStack.back());
 }
 
@@ -91,30 +97,80 @@
 	m_PageStack.pop_back();
 }
 
+void CGUIManager::PopPageCB(shared_ptr<ScriptInterface::StructuredClone> args)
+{
+	shared_ptr<ScriptInterface::StructuredClone> initDataClone = m_PageStack.back().initData;
+	PopPage();
+	
+	shared_ptr<ScriptInterface> scriptInterface = m_PageStack.back().gui->GetScriptInterface();
+	CScriptVal initDataVal;
+	if (initDataClone)
+		initDataVal = scriptInterface->ReadStructuredClone(initDataClone);
+	else
+	{
+		LOGERROR(L"Called PopPageCB when initData (which should contain the callback function name) isn't set!");
+		return;
+	}
+	
+	if (!scriptInterface->HasProperty(initDataVal.get(), "callback"))
+	{
+		LOGERROR(L"Called PopPageCB when the callback function name isn't set!");
+		return;
+	}
+	
+	std::string callback;
+	if (!scriptInterface->GetProperty(initDataVal.get(), "callback", callback))
+	{
+		LOGERROR(L"Failed to get the callback property as a string from initData in PopPageCB!");
+		return;
+	}
+	
+	if (!scriptInterface->HasProperty(scriptInterface->GetGlobalObject(), callback.c_str()))
+	{
+		LOGERROR(L"The specified callback function %hs does not exist in the page %ls", callback.c_str(), m_PageStack.back().name.c_str());
+		return;
+	}
+
+	CScriptVal argVal;
+	if (args)
+		argVal = scriptInterface->ReadStructuredClone(args);
+	if (!scriptInterface->CallFunctionVoid(scriptInterface->GetGlobalObject(), callback.c_str(), argVal))
+	{
+		LOGERROR(L"Failed to call the callback function %hs in the page %ls", callback.c_str(), m_PageStack.back().name.c_str());
+		return;
+	}
+}
+
 void CGUIManager::DisplayMessageBox(int width, int height, const CStrW& title, const CStrW& message)
 {
 	// Set up scripted init data for the standard message box window
 	CScriptValRooted data;
-	m_ScriptInterface.Eval("({})", data);
-	m_ScriptInterface.SetProperty(data.get(), "width", width, false);
-	m_ScriptInterface.SetProperty(data.get(), "height", height, false);
-	m_ScriptInterface.SetProperty(data.get(), "mode", 2, false);
-	m_ScriptInterface.SetProperty(data.get(), "title", std::wstring(title), false);
-	m_ScriptInterface.SetProperty(data.get(), "message", std::wstring(message), false);
+	m_ScriptInterface->Eval("({})", data);
+	m_ScriptInterface->SetProperty(data.get(), "width", width, false);
+	m_ScriptInterface->SetProperty(data.get(), "height", height, false);
+	m_ScriptInterface->SetProperty(data.get(), "mode", 2, false);
+	m_ScriptInterface->SetProperty(data.get(), "title", std::wstring(title), false);
+	m_ScriptInterface->SetProperty(data.get(), "message", std::wstring(message), false);
 
 	// Display the message box
-	PushPage(L"page_msgbox.xml", data.get());
+	PushPage(L"page_msgbox.xml", m_ScriptInterface->WriteStructuredClone(data.get()));
 }
 
 void CGUIManager::LoadPage(SGUIPage& page)
 {
 	// If we're hotloading then try to grab some data from the previous page
-	CScriptValRooted hotloadData;
+	shared_ptr<ScriptInterface::StructuredClone> hotloadData;
 	if (page.gui)
-		m_ScriptInterface.CallFunction(OBJECT_TO_JSVAL(page.gui->GetScriptObject()), "getHotloadData", hotloadData);
+	{	
+		CScriptVal hotloadDataVal;
+		shared_ptr<ScriptInterface> scriptInterface = page.gui->GetScriptInterface();
+		scriptInterface->CallFunction(scriptInterface->GetGlobalObject(), "getHotloadData", hotloadDataVal);
+		hotloadData = scriptInterface->WriteStructuredClone(hotloadDataVal.get());
+	}
+		
+	page.inputs.clear();
+	page.gui.reset(new CGUI(m_ScriptRuntime));
 
-	page.inputs.clear();
-	page.gui.reset(new CGUI());
 	page.gui->Initialize();
 
 	VfsPath path = VfsPath("gui") / page.name;
@@ -160,8 +216,21 @@
 
 	page.gui->SendEventToAll("load");
 
+	shared_ptr<ScriptInterface> scriptInterface = page.gui->GetScriptInterface();
+	CScriptVal initDataVal;
+	CScriptVal hotloadDataVal;
+	if (page.initData) 
+		initDataVal = scriptInterface->ReadStructuredClone(page.initData);
+	if (hotloadData)
+		hotloadDataVal = scriptInterface->ReadStructuredClone(hotloadData);
+	
 	// Call the init() function
-	if (!m_ScriptInterface.CallFunctionVoid(OBJECT_TO_JSVAL(page.gui->GetScriptObject()), "init", page.initData, hotloadData))
+	if (!scriptInterface->CallFunctionVoid(
+			scriptInterface->GetGlobalObject(), 
+			"init", 
+			initDataVal, 
+			hotloadDataVal)
+		)
 	{
 		LOGERROR(L"GUI page '%ls': Failed to call init() function", page.name.c_str());
 	}
@@ -184,14 +253,28 @@
 	return INFO::OK;
 }
 
-CScriptVal CGUIManager::GetSavedGameData()
+CScriptVal CGUIManager::GetSavedGameData(ScriptInterface*& pPageScriptInterface)
 {
 	CScriptVal data;
-	if (!m_ScriptInterface.CallFunction(OBJECT_TO_JSVAL(top()->GetScriptObject()), "getSavedGameData", data))
+	if (!top()->GetScriptInterface()->CallFunction(top()->GetGlobalObject(), "getSavedGameData", data))
 		LOGERROR(L"Failed to call getSavedGameData() on the current GUI page");
+	pPageScriptInterface = GetScriptInterface().get();
 	return data;
 }
 
+std::string CGUIManager::GetSavedGameData()
+{
+	CScriptVal data;
+	top()->GetScriptInterface()->CallFunction(top()->GetGlobalObject(), "getSavedGameData", data);
+	return top()->GetScriptInterface()->StringifyJSON(data.get(), false);
+}
+
+void CGUIManager::RestoreSavedGameData(std::string jsonData)
+{
+	top()->GetScriptInterface()->CallFunctionVoid(top()->GetGlobalObject(), "restoreSavedGameData",
+														top()->GetScriptInterface()->ParseJSON(jsonData));
+}
+
 InReaction CGUIManager::HandleEvent(const SDL_Event_* ev)
 {
 	// We want scripts to have access to the raw input events, so they can do complex
@@ -205,7 +288,7 @@
 
 	{
 		PROFILE("handleInputBeforeGui");
-		if (m_ScriptInterface.CallFunction(OBJECT_TO_JSVAL(top()->GetScriptObject()), "handleInputBeforeGui", *ev, top()->FindObjectUnderMouse(), handled))
+		if (top()->GetScriptInterface()->CallFunction(top()->GetGlobalObject(), "handleInputBeforeGui", *ev, top()->FindObjectUnderMouse(), handled))
 			if (handled)
 				return IN_HANDLED;
 	}
@@ -219,8 +302,7 @@
 
 	{
 		PROFILE("handleInputAfterGui");
-		if (m_ScriptInterface.CallFunction(OBJECT_TO_JSVAL(top()->GetScriptObject()), "handleInputAfterGui", *ev, handled))
-			if (handled)
+		if (top()->GetScriptInterface()->CallFunction(top()->GetGlobalObject(), "handleInputAfterGui", *ev, handled))			if (handled)
 				return IN_HANDLED;
 	}
 
@@ -287,11 +369,6 @@
 		it->gui->UpdateResolution();
 }
 
-JSObject* CGUIManager::GetScriptObject()
-{
-	return top()->GetScriptObject();
-}
-
 // This returns a shared_ptr to make sure the CGUI doesn't get deallocated
 // while we're in the middle of calling a function on it (e.g. if a GUI script
 // calls SwitchPage)
Index: source/gui/IGUIObject.cpp
===================================================================
--- source/gui/IGUIObject.cpp	(Revision 14461)
+++ source/gui/IGUIObject.cpp	(Arbeitskopie)
@@ -43,8 +43,7 @@
 IGUIObject::IGUIObject() : 
 	m_pGUI(NULL), 
 	m_pParent(NULL),
-	m_MouseHovering(false),
-	m_JSObject(NULL)
+	m_MouseHovering(false)
 {
 	AddSetting(GUIST_bool,			"enabled");
 	AddSetting(GUIST_bool,			"hidden");
@@ -84,18 +83,6 @@
 			}
 		}
 	}
-
-	{
-		std::map<CStr, JSObject**>::iterator it;
-		for (it = m_ScriptHandlers.begin(); it != m_ScriptHandlers.end(); ++it)
-		{
-			JS_RemoveObjectRoot(g_ScriptingHost.getContext(), it->second);
-			delete it->second;
-		}
-	}
-	
-	if (m_JSObject)
-		JS_RemoveObjectRoot(g_ScriptingHost.getContext(), &m_JSObject);
 }
 
 //-------------------------------------------------------------------
@@ -429,6 +416,11 @@
 
 void IGUIObject::RegisterScriptHandler(const CStr& Action, const CStr& Code, CGUI* pGUI)
 {
+	if(!GetGUI())
+		throw PSERROR_GUI_OperationNeedsGUIObject();
+		
+	JSContext* cx = pGUI->GetScriptInterface()->GetContext();
+	
 	const int paramCount = 1;
 	const char* paramNames[paramCount] = { "mouse" };
 
@@ -440,7 +432,7 @@
 	char buf[64];
 	sprintf_s(buf, ARRAY_SIZE(buf), "__eventhandler%d (%s)", x++, Action.c_str());
 
-	JSFunction* func = JS_CompileFunction(g_ScriptingHost.getContext(), pGUI->m_ScriptObject,
+	JSFunction* func = JS_CompileFunction(cx, JSVAL_TO_OBJECT(pGUI->GetGlobalObject()),
 		buf, paramCount, paramNames, Code.c_str(), Code.length(), CodeName.c_str(), 0);
 
 	if (!func)
@@ -451,16 +443,7 @@
 
 void IGUIObject::SetScriptHandler(const CStr& Action, JSObject* Function)
 {
-	JSObject** obj = new JSObject*;
-	*obj = Function;
-	JS_AddObjectRoot(g_ScriptingHost.getContext(), obj);
-
-	if (m_ScriptHandlers[Action])
-	{
-		JS_RemoveObjectRoot(g_ScriptingHost.getContext(), m_ScriptHandlers[Action]);
-		delete m_ScriptHandlers[Action];
-	}
-	m_ScriptHandlers[Action] = obj;
+	m_ScriptHandlers[Action] = CScriptValRooted(m_pGUI->GetScriptInterface()->GetContext(), OBJECT_TO_JSVAL(Function));
 }
 
 InReaction IGUIObject::SendEvent(EGUIMessageType type, const CStr& EventName)
@@ -479,21 +462,23 @@
 
 void IGUIObject::ScriptEvent(const CStr& Action)
 {
-	std::map<CStr, JSObject**>::iterator it = m_ScriptHandlers.find(Action);
+	std::map<CStr, CScriptValRooted>::iterator it = m_ScriptHandlers.find(Action);
 	if (it == m_ScriptHandlers.end())
 		return;
 
+	JSContext* cx = m_pGUI->GetScriptInterface()->GetContext();
+
 	// Set up the 'mouse' parameter
 	CScriptVal mouse;
-	g_ScriptingHost.GetScriptInterface().Eval("({})", mouse);
-	g_ScriptingHost.GetScriptInterface().SetProperty(mouse.get(), "x", m_pGUI->m_MousePos.x, false);
-	g_ScriptingHost.GetScriptInterface().SetProperty(mouse.get(), "y", m_pGUI->m_MousePos.y, false);
-	g_ScriptingHost.GetScriptInterface().SetProperty(mouse.get(), "buttons", m_pGUI->m_MouseButtons, false);
+	m_pGUI->GetScriptInterface()->Eval("({})", mouse);
+	m_pGUI->GetScriptInterface()->SetProperty(mouse.get(), "x", m_pGUI->m_MousePos.x, false);
+	m_pGUI->GetScriptInterface()->SetProperty(mouse.get(), "y", m_pGUI->m_MousePos.y, false);
+	m_pGUI->GetScriptInterface()->SetProperty(mouse.get(), "buttons", m_pGUI->m_MouseButtons, false);
 
 	jsval paramData[] = { mouse.get() };
 
 	jsval result;
-	JSBool ok = JS_CallFunctionValue(g_ScriptingHost.getContext(), GetJSObject(), OBJECT_TO_JSVAL(*it->second), ARRAY_SIZE(paramData), paramData, &result);
+	JSBool ok = JS_CallFunctionValue(cx, GetJSObject(), (*it).second.get(), ARRAY_SIZE(paramData), paramData, &result);
 	if (!ok)
 	{
 		// We have no way to propagate the script exception, so just ignore it
@@ -503,7 +488,8 @@
 
 void IGUIObject::ScriptEvent(const CStr& Action, const CScriptValRooted& Argument)
 {
-	std::map<CStr, JSObject**>::iterator it = m_ScriptHandlers.find(Action);
+	JSContext* cx = m_pGUI->GetScriptInterface()->GetContext();
+	std::map<CStr, CScriptValRooted>::iterator it = m_ScriptHandlers.find(Action);
 	if (it == m_ScriptHandlers.end())
 		return;
 
@@ -512,25 +498,26 @@
 	jsval arg = Argument.get();
 
 	jsval result;
-	JSBool ok = JS_CallFunctionValue(g_ScriptingHost.getContext(), object, OBJECT_TO_JSVAL(*it->second), 1, &arg, &result);
+	JSBool ok = JS_CallFunctionValue(cx, object, (*it).second.get(), 1, &arg, &result);
 	if (!ok)
 	{
-		JS_ReportError(g_ScriptingHost.getContext(), "Errors executing script action \"%s\"", Action.c_str());
+		JS_ReportError(cx, "Errors executing script action \"%s\"", Action.c_str());
 	}
 }
 
 JSObject* IGUIObject::GetJSObject()
 {
+	JSContext* cx = m_pGUI->GetScriptInterface()->GetContext();
 	// Cache the object when somebody first asks for it, because otherwise
 	// we end up doing far too much object allocation. TODO: Would be nice to
 	// not have these objects hang around forever using up memory, though.
-	if (! m_JSObject)
+	if (m_JSObject.uninitialised())
 	{
-		m_JSObject = JS_NewObject(g_ScriptingHost.getContext(), &JSI_IGUIObject::JSI_class, NULL, NULL);
-		JS_AddObjectRoot(g_ScriptingHost.getContext(), &m_JSObject);
-		JS_SetPrivate(g_ScriptingHost.getContext(), m_JSObject, this);
+		JSObject* obj = JS_NewObject(cx, &JSI_IGUIObject::JSI_class, NULL, NULL);
+		m_JSObject = CScriptValRooted(cx, OBJECT_TO_JSVAL(obj));
+		JS_SetPrivate(cx, JSVAL_TO_OBJECT(m_JSObject.get()), this);
 	}
-	return m_JSObject;
+	return JSVAL_TO_OBJECT(m_JSObject.get());;
 }
 
 CStr IGUIObject::GetPresentableName() const
Index: source/gui/MiniMap.cpp
===================================================================
--- source/gui/MiniMap.cpp	(Revision 14461)
+++ source/gui/MiniMap.cpp	(Arbeitskopie)
@@ -28,6 +28,8 @@
 #include "graphics/TerrainTextureEntry.h"
 #include "graphics/TerrainTextureManager.h"
 #include "graphics/TerritoryTexture.h"
+#include "gui/GUI.h"
+#include "gui/GUIManager.h"
 #include "lib/ogl.h"
 #include "lib/external_libraries/libsdl.h"
 #include "lib/bits.h"
@@ -241,9 +243,9 @@
 	GetMouseWorldCoordinates(x, z);
 
 	CScriptValRooted coords;
-	g_ScriptingHost.GetScriptInterface().Eval("({})", coords);
-	g_ScriptingHost.GetScriptInterface().SetProperty(coords.get(), "x", x, false);
-	g_ScriptingHost.GetScriptInterface().SetProperty(coords.get(), "z", z, false);
+	g_GUI->GetActiveGUI()->GetScriptInterface()->Eval("({})", coords);
+	g_GUI->GetActiveGUI()->GetScriptInterface()->SetProperty(coords.get(), "x", x, false);
+	g_GUI->GetActiveGUI()->GetScriptInterface()->SetProperty(coords.get(), "z", z, false);
 	ScriptEvent("worldclick", coords);
 
 	UNUSED2(button);
Index: source/gui/CGUI.h
===================================================================
--- source/gui/CGUI.h	(Revision 14461)
+++ source/gui/CGUI.h	(Arbeitskopie)
@@ -40,6 +40,7 @@
 
 #include "GUITooltip.h"
 #include "GUIbase.h"
+#include "scriptinterface/ScriptInterface.h"
 
 #include "ps/Overlay.h" // CPos and CRect
 
@@ -107,15 +108,10 @@
 	typedef IGUIObject *(*ConstructObjectFunction)();
 
 public:
-	CGUI();
+	CGUI(const shared_ptr<ScriptRuntime>& runtime);
 	~CGUI();
 
 	/**
-	 * Initializes GUI script classes
-	 */
-	static void ScriptingInit();
-
-	/**
 	 * Initializes the GUI, needs to be called before the GUI is used
 	 */
 	void Initialize();
@@ -260,12 +256,6 @@
 						  const float &Width, const float &BufferZone,
 						  const IGUIObject *pObject=NULL);
 
-	/**
-	 * Returns the JSObject* associated with the GUI
-	 *
-	 * @return The relevant JS object
-	 */
-	JSObject* GetScriptObject() { return m_ScriptObject; }
 
 	/**
 	 * Check if an icon exists
@@ -282,6 +272,9 @@
 	 * Returns false if it fails.
 	 */
 	bool GetPreDefinedColor(const CStr& name, CColor &Output);
+	
+	shared_ptr<ScriptInterface> GetScriptInterface() { return m_ScriptInterface; };
+	jsval GetGlobalObject() { return m_ScriptInterface->GetGlobalObject(); };
 
 private:
 
@@ -581,15 +574,10 @@
 	/** @name Miscellaneous */
 	//--------------------------------------------------------
 	//@{
+	
+	shared_ptr<ScriptInterface> m_ScriptInterface;
 
 	/**
-	 * An JSObject* under which all GUI JavaScript things will
-	 * be created, so that they can be garbage-collected
-	 * when the GUI shuts down.
-	 */
-	JSObject* m_ScriptObject;
-
-	/**
 	 * don't want to pass this around with the 
 	 * ChooseMouseOverAndClosest broadcast -
 	 * we'd need to pack this and pNearest in a struct
Index: source/gui/CGUI.cpp
===================================================================
--- source/gui/CGUI.cpp	(Revision 14461)
+++ source/gui/CGUI.cpp	(Arbeitskopie)
@@ -40,7 +40,7 @@
 #include "CProgressBar.h"
 #include "CTooltip.h"
 #include "MiniMap.h"
-#include "scripting/JSInterface_GUITypes.h"
+#include "scripting/ScriptFunctions.h"
 
 #include "graphics/FontMetrics.h"
 #include "graphics/ShaderManager.h"
@@ -58,19 +58,12 @@
 #include "ps/Pyrogenesis.h"
 #include "ps/XML/Xeromyces.h"
 #include "renderer/Renderer.h"
-#include "scripting/ScriptingHost.h"
 #include "scriptinterface/ScriptInterface.h"
 
 extern int g_yres;
 
 const double SELECT_DBLCLICK_RATE = 0.5;
 
-void CGUI::ScriptingInit()
-{
-	JSI_IGUIObject::init();
-	JSI_GUITypes::init();
-}
-
 InReaction CGUI::HandleEvent(const SDL_Event_* ev)
 {
 	InReaction ret = IN_PASS;
@@ -321,83 +314,12 @@
 //  Constructor / Destructor
 //-------------------------------------------------------------------
 
-// To isolate the vars declared by each GUI page, we need to create
-// a pseudo-global object to declare them in. In particular, it must
-// have no parent object, so it must be declared with JS_NewGlobalObject.
-// But GUI scripts should have access to the real global's properties
-// (Array, undefined, getGUIObjectByName, etc), so we add a custom resolver
-// that defers to the real global object when necessary.
-
-static JSBool GetGlobalProperty(JSContext* cx, JSObject* UNUSED(obj), jsid id, jsval* vp)
+CGUI::CGUI(const shared_ptr<ScriptRuntime>& runtime) : m_MouseButtons(0), m_FocusedObject(NULL), m_InternalNameNumber(0)
 {
-	return JS_GetPropertyById(cx, g_ScriptingHost.GetGlobalObject(), id, vp);
-}
-
-static JSBool SetGlobalProperty(JSContext* cx, JSObject* UNUSED(obj), jsid id, JSBool UNUSED(strict), jsval* vp)
-{
-	return JS_SetPropertyById(cx, g_ScriptingHost.GetGlobalObject(), id, vp);
-}
-
-static JSBool ResolveGlobalProperty(JSContext* cx, JSObject* obj, jsid id, uintN flags, JSObject** objp)
-{
-	// This gets called when the property can't be resolved in the page_global object.
-
-	// Warning: The interaction between this resolution stuff and the JITs appears
-	// to be quite fragile, and I don't quite understand what the constraints are.
-	// If changing it, be careful to test with each JIT to make sure it works.
-	// (This code is somewhat based on GPSEE's module system.)
-
-	// Declarations and assignments shouldn't affect the real global
-	if (flags & (JSRESOLVE_DECLARING | JSRESOLVE_ASSIGNING))
-	{
-		// Can't be resolved - return NULL
-		*objp = NULL;
-		return JS_TRUE;
-	}
-
-	// Check whether the real global object defined this property
-	uintN attrs;
-	JSBool found;
-	if (!JS_GetPropertyAttrsGetterAndSetterById(cx, g_ScriptingHost.GetGlobalObject(), id, &attrs, &found, NULL, NULL))
-		return JS_FALSE;
-
-	if (!found)
-	{
-		// Not found on real global, so can't be resolved - return NULL
-		*objp = NULL;
-		return JS_TRUE;
-	}
-
-	// Retrieve the property value from the global
-	jsval v;
-	if (!JS_GetPropertyById(cx, g_ScriptingHost.GetGlobalObject(), id, &v))
-		return JS_FALSE;
-
-	// Add the global's property value onto this object, with getter/setter that will
-	// update the global's copy instead of this copy, and then return this object
-	if (!JS_DefinePropertyById(cx, obj, id, v, GetGlobalProperty, SetGlobalProperty, attrs))
-		return JS_FALSE;
-
-	*objp = obj;
-	return JS_TRUE;
-}
-
-static JSClass page_global_class = {
-	"page_global", JSCLASS_GLOBAL_FLAGS | JSCLASS_NEW_RESOLVE,
-	JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_StrictPropertyStub,
-	JS_EnumerateStub, (JSResolveOp)ResolveGlobalProperty, JS_ConvertStub, JS_FinalizeStub,
-	NULL, NULL, NULL, NULL,
-	NULL, NULL, NULL, NULL
-};
-
-CGUI::CGUI() : m_MouseButtons(0), m_FocusedObject(NULL), m_InternalNameNumber(0)
-{
+	m_ScriptInterface.reset(new ScriptInterface("Engine", "GUIPage", runtime));
+	GuiScriptingInit(*m_ScriptInterface);
 	m_BaseObject = new CGUIDummyObject;
-	m_BaseObject->SetGUI(this);
-
-	// Construct the root object for all GUI JavaScript things
-	m_ScriptObject = JS_NewGlobalObject(g_ScriptingHost.getContext(), &page_global_class);
-	JS_AddObjectRoot(g_ScriptingHost.getContext(), &m_ScriptObject);
+	m_BaseObject->SetGUI(this);	
 }
 
 CGUI::~CGUI()
@@ -406,12 +328,6 @@
 
 	if (m_BaseObject)
 		delete m_BaseObject;
-
-	if (m_ScriptObject)
-	{
-		// Let it be garbage-collected
-		JS_RemoveObjectRoot(g_ScriptingHost.getContext(), &m_ScriptObject);
-	}
 }
 
 //-------------------------------------------------------------------
@@ -1337,6 +1253,9 @@
 			code += CStr(child.GetText());
 
 			CStr action = CStr(child.GetAttributes().GetNamedItem(attr_on));
+			
+			// We need to set the GUI this object belongs to because RegisterScriptHandler requires an associated GUI.
+			object->SetGUI(this);
 			object->RegisterScriptHandler(action.LowerCase(), code, this);
 		}
 		else if (element_name == elmt_repeat)
@@ -1430,7 +1349,7 @@
 		Paths.insert(file);
 		try
 		{
-			g_ScriptingHost.RunScript(file, m_ScriptObject);
+			m_ScriptInterface->LoadGlobalScriptFile(file);
 		}
 		catch (PSERROR_Scripting& e)
 		{
@@ -1443,7 +1362,7 @@
 	{
 		CStr code (Element.GetText());
 		if (! code.empty())
-			g_ScriptingHost.RunMemScript(code.c_str(), code.length(), "Some XML file", Element.GetLineNumber(), m_ScriptObject);
+			m_ScriptInterface->LoadGlobalScript(L"Some XML file", code.FromUTF8());
 	}
 	catch (PSERROR_Scripting& e)
 	{
Index: source/gui/IGUIObject.h
===================================================================
--- source/gui/IGUIObject.h	(Revision 14461)
+++ source/gui/IGUIObject.h	(Arbeitskopie)
@@ -554,10 +554,10 @@
 	CGUI									*m_pGUI;
 
 	// Internal storage for registered script handlers.
-	std::map<CStr, JSObject**> m_ScriptHandlers;
+	std::map<CStr, CScriptValRooted> m_ScriptHandlers;
 	
 	// Cached JSObject representing this GUI object
-	JSObject								*m_JSObject;
+	CScriptValRooted						m_JSObject;
 };
 
 
Index: source/main.cpp
===================================================================
--- source/main.cpp	(Revision 14461)
+++ source/main.cpp	(Arbeitskopie)
@@ -71,7 +71,6 @@
 #include "graphics/TextureManager.h"
 #include "gui/GUIManager.h"
 #include "renderer/Renderer.h"
-#include "scripting/ScriptingHost.h"
 #include "simulation2/Simulation2.h"
 
 #if OS_UNIX
@@ -185,8 +184,8 @@
 		PROFILE2("event");
 		if (g_GUI)
 		{
-			std::string data = g_GUI->GetScriptInterface().StringifyJSON(
-				ScriptInterface::ToJSVal(g_GUI->GetScriptInterface().GetContext(), ev));
+			std::string data = g_GUI->GetScriptInterface()->StringifyJSON(
+				ScriptInterface::ToJSVal(g_GUI->GetScriptInterface()->GetContext(), ev));
 			PROFILE2_ATTR("%s", data.c_str());
 		}
 		in_dispatch_event(&ev);
@@ -472,7 +471,6 @@
 	while(!quit)
 		Frame();
 	Shutdown(0);
-	ScriptingHost::FinalShutdown(); // this can't go in Shutdown() because that could be called multiple times per process, so stick it here instead
 	MainControllerShutdown();
 
 	if (restart_in_atlas)
Index: source/simulation2/Simulation2.h
===================================================================
--- source/simulation2/Simulation2.h	(Revision 14461)
+++ source/simulation2/Simulation2.h	(Arbeitskopie)
@@ -38,6 +38,7 @@
 class CMessage;
 class SceneCollector;
 class CFrustum;
+class ScriptRuntime;
 
 /**
  * Public API for simulation system.
@@ -48,7 +49,7 @@
 public:
 	// TODO: CUnitManager should probably be handled automatically by this
 	// module, but for now we'll have it passed in externally instead
-	CSimulation2(CUnitManager*, CTerrain*);
+	CSimulation2(CUnitManager* unitManager, shared_ptr<ScriptRuntime> rt, CTerrain* terrain);
 	~CSimulation2();
 
 	void EnableOOSLog();
